<script src="@#file#(fillpoly.js)" type="text/javascript"></script>

<p>Prethodno opisani algoritam za svaku sken-liniju računa sjecišta s pravcima na kojima leže svi bridovi. Ako je poligon velik (proteže se kroz stotine redaka) i ako ima puno bridova, ovo može biti nezanemariv trošak.</p>

<p>Pogledajte još jednom primjer u nastavku. Sken-liniju smo postavili na y=2 što je odgovara y=y<sub>min</sub>.</p>

  <div width="500" height="500" style="position:relative; width:500px; margin: auto;">
  <canvas id="myCanvas3" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var brcanvas3 = new RasterDisplay("myCanvas3", 20, 20);
    var vertexes2 = [{x: 10,y:2, l:"V1"}, {x: 13,y:8, l:"V2"}, {x: 9,y:17, l:"V3"}, {x: 6,y:11, l:"V4"}];
    brcanvas3.fullLines = [
      {x0:vertexes2[0].x,y0:vertexes2[0].y,x1:vertexes2[1].x,y1:vertexes2[1].y,c:"#FF0000",l:"b1 (D)"},
      {x0:vertexes2[1].x,y0:vertexes2[1].y,x1:vertexes2[2].x,y1:vertexes2[2].y,c:"#FF0000",l:"b2 (D)"},
      {x0:vertexes2[2].x,y0:vertexes2[2].y,x1:vertexes2[3].x,y1:vertexes2[3].y,c:"#0000FF",l:"b3 (L)"},
      {x0:vertexes2[3].x,y0:vertexes2[3].y,x1:vertexes2[0].x,y1:vertexes2[0].y,c:"#0000FF",l:"b4 (L)"}
    ];
    brcanvas3.points = vertexes2;
    brcanvas3.showPointLabels = true;
    brcanvas3.showLineLabels = true;
    brcanvas3.showPoints = true;

    brcanvas3.hlines=[{y: 2, c: "#FF0000", d: [5,5]}];

    brcanvas3.paint();
  </script>

<p>Primijetite sada: svaki se brid proteže kroz određen broj redaka nakon čega ga nastavlja sljedeći brid. Kako se sa sken-linijom počinjemo kretati prema dolje (prema većim y-ima), lijeva sjecišta će biti određivana isključivo bridom b4 a desna bridom b1 sve dok ne dođemo do sken-linije y=8. Za raspon y=2 do y=8, aktivni lijevi brid je bio b4 a desni brid b1. Prelaskom na sken-liniju y=8, brid b2 postaje aktivni desni brid i on dalje određuje sva desna sjecišta. Promjena se, međutim, još mora dogoditi na lijevoj strani, i događa se prelaskom na sken-liniju y=11. Tada aktivni lijevi brid postaje brid b3 i on određuje sva daljnja lijeva sjecišta.</p>

<p>Kako možemo iskoristiti ovu spoznaju? Evo ideje. Kao i prije, bridove ćemo razdijeliti u lijeve i desne, ali ovaj puta doslovno: napravit ćemo polje lijevih bridova <code>lb=[b3,b4]</code> i desnih bridova <code>db=[b1,b2]</code> (polja smo popunili redosljedom kojim smo generirali bridove; elementi polja su sami bridovi ili mogu biti pokazivači na njih). Potom ćemo polje desnih bridova sortirati po y-koordinati početnog vrha čime dobivamo <code>db=[b1,b2]</code> (nije bilo promjene). Polje lijevih bridova sortirat ćemo po po y-koordinati dolaznog vrha čime dobivamo <code>db=[b4,b3]</code> (bilo je promjene). Uvest ćemo dva dodatna indeksa: <code>albi=0</code> i <code>adbi=0</code> (aktivni-lijevi-brid-indeks i aktivni-desni-brid-indeks).</p>

<p>I sada glavni dio algoritma: za svaku novu sken-liniju y provjerit ćemo:</p>
<ol>
<li>Brid <code>b=db[adbi+1]</code>. Ako je y-koordinata početnog vrha brida b manja ili jednaka y, <code>adbi++</code> (drugim riječima, taj brid proglašavamo aktivnim; u suprotnom <code>adbi</code> ne diramo).</li>
<li>Brid <code>b=lb[albi+1]</code>. Ako je y-koordinata završnog vrha brida b manja ili jednaka y, <code>albi++</code> (drugim riječima, taj brid proglašavamo aktivnim; u suprotnom <code>albi</code> ne diramo).</li>
<li>Izračunati L kao sjecište sken-linije y i brida lb[albi+1].</li>
<li>Izračunati D kao sjecište sken-linije y i brida db[adbi+1].</li>
<li>Obojati vodoravni dio (L,y) do (D,y).</li>
</ol>

<p>Korake 2 i 3 treba svaki za sebe staviti u petlju jer je moguće da poligon ima vodoravnih bridova pa takve treba preskočiti.</p>

<p>Opisani algoritam inicijalno je nešto skuplji od prethodne inačice: morat će alocirati dodatna polja te na početku utrošiti vrijeme na sortiranje. Međutim, kasnije to nadoknađuje bitno manjim troškom obrade svake od sken-linija.</p>

<p>I za kraj još napomenimo da je osnovna pretpostavka opisanog algoritma da radimo s konveksnim poligonima.</p>

